V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
pheyer
V2EX  ›  macOS

这年头还有在 Mac 下用 git svn 的吗?

  •  
  •   pheyer · 2021-07-13 09:52:57 +08:00 · 5403 次点击
    这是一个创建于 1013 天前的主题,其中的信息可能已经有所发展或是发生改变。
    前情提要:公司一直用 SVN 做代码管理,大概只有我一个人用 git svn 吧。
    自从 Xcode 干掉 svn 后,用 git svn 就越来越麻烦了,最近升级到最新的系统后 git svn 命令又不能用了,折腾了两天都没有搞定,太废了

    这是最开始遇到的问题:
    Can't locate SVN/Core.pm in @INC (you may need to install the SVN::Core module)

    现在报的问题是:
    svn: E235000: In file 'subversion/bindings/swig/perl/libsvn_swig_perl/swigutil_pl.c' line 1666: assertion failed (get_current_pool_cb != NULL)
    error: git-svn died of signal 6

    svn 版本 1.14.1,git 版本从 2.32.0 到 2.27.0 、2.26.2 版本都试了,没有解决问题😭
    18 条回复    2023-11-18 20:47:59 +08:00
    Spoter
        1
    Spoter  
       2021-07-13 09:56:17 +08:00
    换公司
    Leonard
        2
    Leonard  
       2021-07-13 09:57:43 +08:00
    cornerstone 能用吗
    hahaFck
        3
    hahaFck  
       2021-07-13 09:57:51 +08:00
    我们公司就用 svn 啊,我是用 homebrew 下的 svn,没用过那个 gitsvn 。
    Smash
        4
    Smash  
       2021-07-13 09:59:52 +08:00
    无解,换公司.
    chouchoui
        5
    chouchoui  
       2021-07-13 10:01:25 +08:00
    git svn 倒是没有,一直用的 homebrew 的 svn,但是自从 macOS 11.3 更新之后 svn 就再也连不上公司 svn 服务器了,非要从 Surge 代理 绕一圈才行
    借楼问问有没有人遇到 E170013 E120108 错误
    pheyer
        6
    pheyer  
    OP
       2021-07-13 10:04:54 +08:00
    @Leonard 公司规定不能用 CornerStone,所以一直用免费的 SourceTree 配置 git svn 使用
    pheyer
        7
    pheyer  
    OP
       2021-07-13 10:06:17 +08:00
    @chouchoui 你这问题也有点奇葩啊
    gesse
        8
    gesse  
       2021-07-13 10:54:52 +08:00
    Versions 很不错, 这个 svn 客户端
    SoloCompany
        9
    SoloCompany  
       2021-07-13 11:17:16 +08:00
    1. m1 到现在还不支持 (perl 的问题), 只能选择 Rosetta 版本
    2. 其它问题可关注这个 https://github.com/Homebrew/homebrew-core/issues/52490
    Chingim
        10
    Chingim  
       2021-07-13 12:05:29 +08:00 via iPhone
    迁到 git 吧。svn 的生态比 git 差太多了
    balabalaguguji
        11
    balabalaguguji  
       2021-07-13 13:42:37 +08:00
    smartsvn
    wowbaby
        12
    wowbaby  
       2021-07-13 13:49:44 +08:00
    svn 真不好用,冲突改好麻烦
    pheyer
        13
    pheyer  
    OP
       2021-07-13 17:58:06 +08:00   ❤️ 1
    @SoloCompany 这个 github issue 以前也看到过,当时是没有解决
    刚才是彻底解决了,解决办法的核心命令是:
    brew install automake swig scons
    brew unlink subversion
    brew install subversion --HEAD --build-from-source

    我猜用这个方法解决问题的原因是:从源码编译 subversion 是直接使用本地 perl 版本编译的的,这样就不存在 perl 依赖版本与本地 perl 版本不一致的问题。用 brew install subversion 直接安装 svn 是很有可能出现它的 perl 依赖与本地 perl 版本不一致的,这也是造成出现“Can't locate SVN/Core.pm”的根本原因
    pheyer
        14
    pheyer  
    OP
       2021-07-13 18:06:43 +08:00
    补充一下我解决问题的环境信息
    系统: macOS Big Sur 11.4
    git version 2.26.2
    svn version: 1.15.0-dev (under development) ——这个应该是使用源码编译的结果
    perl version 5.30.2
    perl path: /usr/bin/perl
    使用源码编译安装 svn 成功后,确保下面的目录是存在的:
    /usr/local/opt/subversion/lib/perl5/site_perl/5.32.0
    Malone
        15
    Malone  
       2021-07-14 10:55:08 +08:00
    之前公司产品文档放 svn 的 每次更新都要拉半天
    pheyer
        16
    pheyer  
    OP
       2021-07-14 11:07:22 +08:00
    刚才才发现本地 perl version 是 5.30.2,/usr/local/opt/subversion/lib/perl5/site_perl/ 目录下的是 5.32.0,版本是不一致的,之前眼花以为两者是一样的。
    zhuifeng1017
        17
    zhuifeng1017  
       2021-07-14 23:29:00 +08:00
    前段时间为了将 svn 迁移到 git, 这个命令在 macos 上死活执行报错。后来开了个 centos 虚拟机,轻松搞定
    helee9199
        18
    helee9199  
       155 天前
    @chouchoui 不知道这里能不能挖坟。我目前就碰到了这个问题, 不过我电脑是 21 年 12 月份买的 M1 电脑。
    当时 brew 装完 svn 都可以使用。直到我前几天重装了系统,再装 svn 就连不上公司服务器了。
    找遍了所有资料,推测是公司服务器的 svnserve 版本太老,还是 09 年的 1.6.6 版本 TLSv1
    后来 brew 装的 svn 。已经这不再支持 TLSv1 了,所以连不上了。
    关于   ·   帮助文档   ·   博客   ·   API   ·   FAQ   ·   我们的愿景   ·   实用小工具   ·   885 人在线   最高记录 6543   ·     Select Language
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.5 · 30ms · UTC 20:06 · PVG 04:06 · LAX 13:06 · JFK 16:06
    Developed with CodeLauncher
    ♥ Do have faith in what you're doing.